;-- Use X-ASM for compile this source code, http://atariarea.histeria.pl/x-asm/
;-
;- Graph2Font v3.5 - Tebe(Tomasz Biela) / Madteam
;- podrasowany odpowiednik procedury stosowanej przy MCS
;-
;- komentarz "too many changes in line" oznacza ze jest za duzo rozkazow STA podczas
;- tworzenia linii obrazu przez Antic, trzeba to poprawic pod G2F

 opt h+
 org $2000

scr48 equ %00111111	;obraz szeroki  *-screen 48b
scr40 equ %00111110	;obraz normalny *-screen 40b
scr32 equ %00111101	;obraz waski    *-screen 32b
pmBase equ $b000

Player0_PositionX equ $d000
Player1_PositionX equ $d001
Player2_PositionX equ $d002
Player3_PositionX equ $d003

Missile0_PositionX equ $d004
Missile1_PositionX equ $d005
Missile2_PositionX equ $d006
Missile3_PositionX equ $d007

Player0_Size equ $d008
Player1_Size equ $d009
Player2_Size equ $d00a
Player3_Size equ $d00b

Missiles_Size equ $d00c

Player0_Missile0_Color0_PM0 equ $d012
Player1_Missile1_Color1_PM1 equ $d013
Player2_Missile2_Color2_PM2 equ $d014
Player3_Missile3_Color3_PM3 equ $d015

Playfield_Color0_PF0 equ $d016
Playfield_Color1_PF1 equ $d017
Playfield_Color2_PF2 equ $d018
Playfield_Color3_PF3 equ $d019
Background_BAK       equ $d01a

PRIOR_GTIACTL equ $d01b
CHARBASE equ $d409


main

;- init PMG
 lda >pmBase
 sta $d407
 lda #3
 sta $d01d		;PMCTL - wyswietlac duchy i pociski
                        *- PMCTL - show sprites and missiles
 lda 20			;czekamy 1 ramke zanim zrobimy jakies nieszczescie :)
 cmp 20                 *- wait 1 frame
 beq *-2

 sei		        ;wylaczenie przerwan *- IRQ OFF, NMI OFF
 lda #0
 sta $d40e
 lda #$fe               ;wylaczenie ROM-u *- ROM OFF
 sta $d301

 mwa #nmi $fffa         ;nasza nowa obsluga przerwania NMI
                        *- new NMI routine
 lda #$c0               ;wlaczenie NMI z przerwaniami DLI
 sta $d40e              *- NMI ON with DLI interrupt

null jmp dli1           ;tutaj CPU sie nudzi, nie wolno nic tutaj robic
                        *- over, no more routines or system crash
;--

 org $2100-16

dli1
 lda $d40b
 cmp #2
 bne dli1
 :3 sta $d40a

 mwa #null null+1
 jmp null

dli2
 lda >fnt+$400*$01
 sta $d40a                     ;line=24
 sta CHARBASE
 lda <dli3
 sta dliv+1
 rti

dli3
 lda >fnt+$400*$02
 sta $d40a                     ;line=48
 sta CHARBASE
 lda <dli4
 sta dliv+1
 rti

dli4
 lda >fnt+$400*$03
 sta $d40a                     ;line=72
 sta CHARBASE
 lda <dli5
 sta dliv+1
 rti

dli5
 lda >fnt+$400*$04
 sta $d40a                     ;line=96
 sta CHARBASE
 lda <dli6
 sta dliv+1
 rti

dli6
 lda >fnt+$400*$05
 sta $d40a                     ;line=120
 sta CHARBASE
 sta $d40a                     ;line=121
 sta $d40a                     ;line=122
 lda #$02
 sta $d40a                     ;line=123
 sta Background_BAK
 lda <dli7
 sta dliv+1
 rti

dli7
 lda >fnt+$400*$06
 sta $d40a                     ;line=144
 sta CHARBASE
 sta $d40a                     ;line=145
 sta $d40a                     ;line=146
 sta $d40a                     ;line=147
 sta $d40a                     ;line=148
 sta $d40a                     ;line=149
 lda #$14
 sta $d40a                     ;line=150
 sta Playfield_Color2_PF2
 lda #$B0
 sta $d40a                     ;line=151
 sta Background_BAK
 sta $d40a                     ;line=152
 sta $d40a                     ;line=153
 sta $d40a                     ;line=154
 sta $d40a                     ;line=155
 sta $d40a                     ;line=156
 sta $d40a                     ;line=157
 sta $d40a                     ;line=158
 sta $d40a                     ;line=159
 sta $d40a                     ;line=160
 lda #$01
 ldx #$9D
 ldy #$72
 sta $d40a                     ;line=161
 sta Player0_Size
 stx Player0_PositionX
 sty Player0_Missile0_Color0_PM0
 sta $d40a                     ;line=162
 sta $d40a                     ;line=163
 lda #$01
 ldx #$9D
 sta $d40a                     ;line=164
 sta Player1_Size
 stx Player1_PositionX
 lda <dli8
 sta dliv+1
 rti

dli8
 lda >fnt+$400*$07
 sta $d40a                     ;line=168
 sta CHARBASE
 sta $d40a                     ;line=169
 sta $d40a                     ;line=170
 sta $d40a                     ;line=171
 sta $d40a                     ;line=172
 lda #$F1
 sta $d40a                     ;line=173
 sta Missiles_Size
 sta $d40a                     ;line=174
 sta $d40a                     ;line=175
 sta $d40a                     ;line=176
 sta $d40a                     ;line=177
 sta $d40a                     ;line=178
 sta $d40a                     ;line=179
 sta $d40a                     ;line=180
 sta $d40a                     ;line=181
 lda #$03
 ldx #$5F
 sta $d40a                     ;line=182
 sta Player1_Size
 stx Player1_PositionX
 stx Missile0_PositionX
 mwa #dli9 dliv+1
 rti

dli9
 lda >fnt+$400*$08
 sta $d40a                     ;line=192
 sta CHARBASE
 sta $d40a                     ;line=193
 lda #$03
 ldx #$97
 ldy #$02
 sta $d40a                     ;line=194
 sta Player0_Size
 stx Player0_PositionX
 sty Player0_Missile0_Color0_PM0
 sta $d40a                     ;line=195
 sta $d40a                     ;line=196
 sta $d40a                     ;line=197
 lda #$00
 ldx #$7D
 sta $d40a                     ;line=198
 sta Player1_Size
 stx Player1_PositionX
 sta $d40a                     ;line=199
 sta $d40a                     ;line=200
 lda #$F0
 sta $d40a                     ;line=201
 sta Missiles_Size
 lda <dli10
 sta dliv+1
 rti

dli10
 lda >fnt+$400*$09
 sta $d40a                     ;line=216
 sta CHARBASE
 sta $d40a                     ;line=217
 sta $d40a                     ;line=218
 sta $d40a                     ;line=219
 sta $d40a                     ;line=220
 sta $d40a                     ;line=221
 sta $d40a                     ;line=222
 sta $d40a                     ;line=223
 sta $d40a                     ;line=224
 sta $d40a                     ;line=225
 lda #$34
 sta $d40a                     ;line=226
 sta Player1_Missile1_Color1_PM1
 rti

;---

nmi bit $d40f
 bpl vbl

dliv jmp dliQ

vbl pha      		;przerwanie VBL *- VBL routine
; txa
; pha
; tya
; pha
 sta $d40f		;reset znacznika przerwania $d40f

 mwa #ant $d402		;adres programu ANTICA pod adres ($d402)
 lda #scr40		;ustawienie szerokosci obrazu
 sta $d400

;- init pierwszej linii

 lda >fnt+$400*$00
 sta CHARBASE
 lda #$22
 sta Background_BAK
 lda #$0A
 sta Playfield_Color0_PF0
 lda #$00
 sta Playfield_Color1_PF1
 lda #$16
 sta Playfield_Color2_PF2
 lda #$08
 sta Playfield_Color3_PF3
 lda #$04
 sta PRIOR_GTIACTL
 lda #$03
 sta Player2_Size
 sta Player3_Size
 lda #$F0
 sta Missiles_Size
 lda #$7F
 sta Player2_PositionX
 lda #$57
 sta Player3_PositionX
 lda #$9F
 sta Missile2_PositionX
 lda #$77
 sta Missile3_PositionX
 lda #$04
 sta Player2_Missile2_Color2_PM2
 sta Player3_Missile3_Color3_PM3
 lda #$00
 sta Player1_Size
 lda #$7D
 sta Player1_PositionX
 lda #$22
 sta Player1_Missile1_Color1_PM1
 lda #$00
 sta Player0_Size
 lda #$7D
 sta Player0_PositionX
 lda #$34
 sta Player0_Missile0_Color0_PM0
 lda #$63
 sta Missile0_PositionX

 mwa #dli2 dliv+1         ;DLI ustawiamy na poczatek
 mwa #dli1 null+1         ;odpalamy synchro pierwszej linii

;- tutaj miejsce na twoja procedurke, tylko zachowaj wartosci rejestrow X i Y
;*- this area is for yours routine, register X,Y must survive

; pla
; tay
; pla
; tax
 pla
dliQ rti

;--
 org $3000
text  ins 'turrican.scr'

;--
 org $3600
ant dta b($44),a(text)
 dta b(4,$84,4,4,$84,4,4,$84,4,4,$84,4,4,$84,4,4,$84,4,4,$84,4,4,$84,4,4,$84,4,4,4)
 dta b($41),a(ant)

;--
 org $3800
fnt ins 'turrican.fnt'

;--
 org pmBase+$300
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0)
 dta b($F0,$E0,$E0,$E0,$C0,$C0,$C0,$C0,$C0,$F0,$F0,$F0,$F0,$F0,$F0,$F0)
 dta b($F0,$F0,$F0,$F0,$F0,$90,$C0,$80,$C0,$90,$C0,$E0,$60,$70,$70,$70)
 dta b($70,$70,$40,$C0,$C0,$C0,$E0,$F0,$E0,$F0,$40,$40,$40,$40,$40,$40)
 dta b($40,$40,$40,$40,$40,$40,$40,$60,$70,$70,$70,$70,$70,$40,$40,$40)
 dta b($C0,$40,$40,$C0,$40,$C0,$C0,$40,$50,$60,$70,$70,$70,$50,$C0,$40)
 dta b($70,$70,$70,$40,$50,$60,$40,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0)
 dta b($C0,$E0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$D0,$F0,$D0,$C0,$F0,$C0,$F0)
 dta b($F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$D0,$F0,$C0,$C0)
 dta b($C0,$E0,$E0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0)
 dta b($F0,$50,$40,$40,$40,$C0,$D0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0)
 dta b($E0,$E0,$F0,$E0,$E0,$E0,$F0,$F0,$F0,$F0,$F1,$F1,$F3,$F3,$F1,$F1)
 dta b($F2,$B2,$33,$B3,$F3,$F2,$F1,$F0,$F3,$F3,$F2,$F3,$F2,$F3,$F3,$F3)
 dta b($F3,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0)
 dta b($E0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$D0,$50,$40,$40,$40,$40,$40,$C0)
 dta b($C0,$C0,$C0,$C0,$C0,$C0,$C0,$F0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF)

 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$CF,$F5,$E6,$C3,$CD,$7F)
 dta b($5F,$7D,$7D,$59,$71,$23,$B7,$9E,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$C0,$80,$C0,$84,$C0,$F8,$FC)
 dta b($64,$66,$FE,$E3,$E7,$63,$7F,$BB,$39,$F8,$79,$19,$FD,$59,$AD,$AD)
 dta b($3D,$0F,$07,$FE,$00,$00,$00,$00,$00,$00,$9F,$BF,$9F,$BF,$FF,$FF)
 dta b($2F,$5F,$DF,$9F,$7F,$DF,$1F,$5F,$7F,$FF,$1F,$5F,$1F,$5F,$1F,$5F)
 dta b($3F,$58,$88,$00,$08,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF)

 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$F7,$CF,$FD,$FE,$FF,$FF,$7F)
 dta b($7D,$7F,$7F,$7F,$7F,$3F,$BF,$9E,$8F,$FF,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$84,$C0,$F8,$FC)
 dta b($7C,$7E,$FE,$FF,$FF,$7F,$7F,$BB,$39,$FA,$7F,$1F,$FF,$00,$D7,$47)
 dta b($CB,$C3,$D3,$C7,$D6,$F4,$D5,$C8,$C4,$C1,$94,$D9,$97,$D9,$97,$FF)
 dta b($FF,$FF,$F7,$AB,$FF,$FF,$FE,$FE,$FE,$F6,$FB,$FF,$FF,$FF,$FF,$E2)
 dta b($CF,$FF,$FF,$DB,$DF,$DF,$FF,$F7,$8F,$FF,$FF,$FF,$FF,$FD,$00,$00)
 dta b($00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF)

 dta b($00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF)
 dta b($FF,$FF,$FF,$EF,$FF,$FF,$BE,$BC,$78,$FC,$FD,$F0,$FB,$F1,$FF,$FB)
 dta b($FB,$FF,$FF,$FF,$FF,$FE,$70,$F0,$F0,$F0,$78,$7C,$7D,$7C,$7C,$7C)
 dta b($3C,$38,$18,$18,$18,$7C,$BF,$FF,$FF,$BF,$FA,$A8,$EC,$FE,$BE,$BE)
 dta b($98,$80,$80,$80,$B8,$9F,$FF,$DF,$DF,$DF,$DF,$C3,$C1,$E0,$C0,$E0)
 dta b($E0,$E0,$F8,$F8,$FC,$F8,$F8,$F0,$F0,$F7,$FF,$FF,$FF,$FC,$F9,$F8)
 dta b($F8,$F8,$F8,$F8,$F8,$FE,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F8)
 dta b($FC,$FF,$FF,$FF,$FF,$FF,$FF,$FD,$FD,$FE,$F9,$FE,$FD,$FC,$FE,$FF)
 dta b($FF,$FF,$FB,$FF,$FF,$FF,$FF,$F3,$F3,$F3,$F3,$F1,$F4,$F8,$F0,$F8)
 dta b($F3,$F7,$F7,$F7,$F7,$FF,$FF,$FD,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF)
 dta b($FB,$FD,$F9,$FD,$FD,$FD,$FD,$FD,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF)
 dta b($FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF)
 dta b($FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF)
 dta b($FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF)
 dta b($FF,$FE,$FE,$FC,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8)
 dta b($F8,$F0,$F0,$F0,$F0,$F0,$F0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF)

 dta b($00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF)
 dta b($FF,$F7,$E3,$E7,$E3,$E3,$E7,$E7,$F7,$63,$33,$23,$21,$01,$00,$00)
 dta b($00,$01,$D0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$E3,$E1,$61,$00,$00,$00)
 dta b($00,$00,$00,$E2,$FE,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$FE,$FE,$FC,$FC)
 dta b($F8,$F0,$64,$20,$03,$0B,$13,$58,$98,$1C,$09,$01,$81,$93,$F3,$FF)
 dta b($FF,$FF,$FF,$FF,$FF,$FF,$FF,$7F,$7F,$7F,$7F,$11,$01,$01,$4B,$3F)
 dta b($13,$43,$03,$03,$83,$83,$FB,$FF,$BF,$1F,$0B,$03,$03,$03,$17,$7F)
 dta b($FF,$FF,$C7,$DF,$3D,$05,$05,$81,$E9,$FD,$F5,$91,$01,$07,$23,$07)
 dta b($07,$37,$7F,$7F,$7F,$67,$21,$3B,$3B,$3D,$9B,$11,$10,$10,$10,$20)
 dta b($25,$7F,$BE,$7B,$DF,$C7,$CF,$07,$C7,$37,$F9,$F9,$FB,$EE,$FB,$F8)
 dta b($80,$88,$08,$08,$08,$88,$40,$08,$00,$48,$40,$48,$21,$09,$09,$01)
 dta b($C9,$CB,$8B,$8B,$8F,$8F,$8F,$8F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$1F)
 dta b($0F,$1F,$1F,$1F,$1F,$1F,$3F,$1F,$1F,$1F,$1F,$3F,$3F,$7F,$7F,$7F)
 dta b($7F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF)
 dta b($FF,$FF,$FF,$DF,$DF,$88,$80,$00,$10,$10,$50,$51,$D0,$D0,$D0,$C0)
 dta b($C0,$C4,$C0,$C1,$E1,$E5,$D5,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF)

 run main
